version: '3.3'
networks:
  arvan:
    driver: bridge

services:
  app:
    build:
      context: .
      dockerfile: deploy/app/Dockerfile
    restart: on-failure
    networks:
      - arvan

    environment:
      #      DOCKER_HOST=$(ip -4 addr show docker0 | grep -Po 'inet \K[\d.]+')
      PHP_OPCACHE_ENABLE : 0
      #      XDEBUG_CONFIG: remote_host=host.docker.internal remote_port=9001 remote_enable=1 remote_autostart=off remote_log=/var/www/html/xdebug.log
      #      XDEBUG_CONFIG: remote_host=172.18.0.1 remote_port=9001 remote_enable=1 remote_autostart=off remote_log=/var/www/html/xdebug.log
      XDEBUG_CONFIG: remote_host=172.17.0.1 remote_port=9001 remote_enable=1 remote_autostart=off
    #      XDEBUG_CONFIG: remote_host=dockerhost remote_port=9001 remote_enable=1 remote_autostart=off

    user: "1000:33"
    volumes:
      - .:/var/www/html

  testing:
    build:
      context: .
      dockerfile: deploy/app/Dockerfile
    networks:
      - arvan

    environment:
      #      DOCKER_HOST=$(ip -4 addr show docker0 | grep -Po 'inet \K[\d.]+')
      PHP_OPCACHE_ENABLE : 0
      #      XDEBUG_CONFIG: remote_host=host.docker.internal remote_port=9001 remote_enable=1 remote_autostart=off remote_log=/var/www/html/xdebug.log
      #      XDEBUG_CONFIG: remote_host=172.18.0.1 remote_port=9001 remote_enable=1 remote_autostart=off remote_log=/var/www/html/xdebug.log
      XDEBUG_CONFIG: remote_host=172.17.0.1 remote_port=9001 remote_enable=1 remote_autostart=off
    #      XDEBUG_CONFIG: remote_host=dockerhost remote_port=9001 remote_enable=1 remote_autostart=off

    user: "1000:33"
    volumes:
      - .:/var/www/html

  nginx:
    build:
      context: .
      dockerfile: ./deploy/nginx/Dockerfile

    depends_on:
      - app
    ports:
      - "80:80"
      - "443:443"

    volumes:
      - ./public:/usr/share/nginx/html
      - ./deploy/nginx/nginx.conf:/etc/nginx/nginx.conf
      - ./deploy/nginx/dummy_ssl/fullchain.pem:/etc/letsencrypt/live/localhost/fullchain.pem
      - ./deploy/nginx/dummy_ssl/privkey.pem:/etc/letsencrypt/live/localhost/privkey.pem
      - ./deploy/nginx/dummy_ssl/options-ssl-nginx.conf:/etc/letsencrypt/options-ssl-nginx.conf
      - ./deploy/nginx/dummy_ssl/ssl-dhparams.pem:/etc/letsencrypt/ssl-dhparams.pem
      - type: bind
        source: ./storage/app/public
        target: /usr/share/nginx/html/storage
        read_only: true

    restart: on-failure
    command: [nginx-debug, '-g', 'daemon off;']
    networks:
      - arvan

#  db:
#
#    image: mysql:8.0
#    environment:
#      MYSQL_ROOT_PASSWORD: secret
#      MYSQL_DATABASE: ${DB_DATABASE}
#      MYSQL_USER: ${DB_USERNAME}
#      MYSQL_PASSWORD: ${DB_PASSWORD}
#    command: --default-authentication-plugin=mysql_native_password
#    ports:
#      - "3307:3306"
#    networks:
#      - arvan
#    volumes:
#        - mysqldata:/var/lib/mysql

  db:
    image: arashidos/laravel-postgres:11.1

    volumes:
      - psqldata:/var/lib/postgresql/data

    ports:
      - "5439:5432"
    environment:
      - POSTGRES_DB=postgres
      - POSTGRES_USER=postgres
      - POSTGRES_PASSWORD=postgresrootpassword
      - PROJECT_DB_NAME=${DB_DATABASE}
      - PROJECT_DB_USERNAME=${DB_USERNAME}
      - PROJECT_DB_PASSWORD=${DB_PASSWORD}

    restart: on-failure
    networks:
      - arvan

  pgadmin:
    image: dpage/pgadmin4:latest

    ports:
      - "82:82"
    restart: on-failure

    networks:
      - arvan

    environment:
      - PGADMIN_DEFAULT_EMAIL=arash.mocio@gmail.com
      - PGADMIN_DEFAULT_PASSWORD=secret
      - PGADMIN_LISTEN_PORT=82

#  phpmyadmin:
#    image: phpmyadmin/phpmyadmin:4.8
#    networks:
#      - arvan
#
#    environment:
#      - PMA_ARBITRARY=1
#    restart: always
#    ports:
#      - 8080:80
#    volumes:
#      - /sessions

volumes:
  mysqldata:
    driver: local
  psqldata:
    driver: local

